<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\SectorService;

class SectorController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $SectorService;
   
    public function __construct($crudService, $environment, SectorService $SectorService) {
        parent::__construct($crudService, $environment);
        $this->SectorService = $SectorService;
    }
    
    public function listSector(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $sectors = $this->SectorService->listSector($params);
        $dtsVal = new DataSet('Sectors', $sectors);
        $response->addDataSet($dtsVal);
    }
}

?>