<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class SetoresFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
   
    public function getSectorsFactory($validParam) {
        $sql = "SELECT A.NRSETOR, A.NMSETOR, A.NRFUNCRESPONSAVEL, B.NMFUNCIONARIO
                    FROM FCM_SETOR A
               LEFT JOIN FCM_FUNCIONARIO B ON A.NRFUNCRESPONSAVEL = B.NRFUNCIONARIO".$validParam;
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function sectorsListFactory() {
        $sql = "SELECT NRSETOR, NMSETOR
                FROM FCM_SETOR";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function createSectorFactory($sectorInfos) {
        $sql = "INSERT INTO FCM_SETOR (NRSETOR, NMSETOR, IDATIVO, DTINCLUSAO, NRFUNCRESPONSAVEL)                          
                    VALUES (:NRSETOR, :NMSETOR, :IDATIVO, SYSDATE, :NRFUNCRESPONSAVEL)";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($sectorInfos);
    }

    public function getSectorInfosFactory($params) {
        $sql = "SELECT NRSETOR, NMSETOR, NRFUNCRESPONSAVEL
                    FROM FCM_SETOR
                WHERE NRSETOR = :NRSETOR";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function updateSectorFactory($params) {
        $sql = "UPDATE FCM_SETOR
                    SET NMSETOR = :NMSETOR,
                        NRFUNCRESPONSAVEL = :NRFUNCRESPONSAVEL
                WHERE NRSETOR = :NRSETOR";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute($params);
    }
    
    public function deleteSectorsFactory($params) {
        $sql = "DELETE FROM FCM_SETOR
                 WHERE NRSETOR = :NRSETOR";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
    }
    
    public function validSectorsInLocalFactory($params) {
        $sql = "SELECT COUNT (*) AS VALIDA
                    FROM FCM_LOCALCLI
                 WHERE NRSETOR = :NRSETOR";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function validSectorsInChecklistFactory($params) {
        $sql = "SELECT COUNT (*) AS VALIDA
                    FROM FCM_CHECKLIST
                 WHERE NRSETOR = :NRSETOR";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function validSectorsInRelacFuncFactory($params) {
        $sql = "SELECT COUNT (*) AS VALIDA
                    FROM FCM_RELACFUNCSETOR
                 WHERE NRSETOR = :NRSETOR";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        return $std->fetchAll();
    }
    
     public function getLinkedLocalsFactory($params) {
        $sql = "SELECT NRLOCALCLIENTE, NMLOCALCLIENTE
                    FROM FCM_LOCALCLI
                WHERE NRSETOR = {$params}";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
}
?>

