<?php

namespace FM\Service;

use FM\Factory\TarefaRecorrenteFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class TarefaRecorrenteService {

    protected $TarefaRecorrenteFactory;
    protected $CardsService;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, TarefaRecorrenteFactory $TarefaRecorrenteFactory, Environment $Environment, NewCode $newCode) {
        $this->connection = $entityManager->getConnection();
        $this->TarefaRecorrenteFactory = $TarefaRecorrenteFactory;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }
    
    public function tarefaRecorrente($param){
        $this->connection->beginTransaction();
        try {
            forEach($param['HORAS'] as $dados){
                $paramDB = array(
                    "NRTAREFARECORRENTE" => $this->newCode->getCodeByTableName("FCM_TAREFARECORRENTE ", 20, 1, 10, true),
                    "NMTAREFA" => $param['NMTAREFA'],
                    "TPLOCALTAREFA" => null,
                    "LOCALTAREFA" => implode(',',$param['LOCAL']),
                    "NRCHECKLIST" => $param['CHECKLIST'],
                    "ITENSCHECKLIST" => implode(',',$param['ITENSCHECK']),
                    "ESCOPOSTAREFA" => null,
                    "ITENSTAREFA" => implode(',',$param['TAREFA']),
                    "CRITERIOS" => json_encode($param['CRITERIOS']),
                    "DIASSEMANA" => $param['DIASSEMANA'],
                    "HORARIO" => $dados['HORARIO'],
                    "DURACAO" => $dados['DURACAO'],
                    "NRFUNCTAREFA" => $dados['NRFUNCIONARIO'],
                    "NRFUNCVISTORIA" => $dados['NRENCARREGADO'],
                    "IDCRIARVISTORIA" => ($dados["VISTORIAAUTOMATICA"]) ? 'S' : 'N',
                    "NRORG" => 20,
                    "IDATIVO" => 'S'
                );
                $this->TarefaRecorrenteFactory->tarefaRecorrente($paramDB);
            }
            $this->connection->commit();
            $response = "OK";
        }
        catch(\Exception $e) {
             $this->connection->rollback();
             $response = "Erro".utf8_decode($e->getErrorCode());
        }
        return $response;
    }
    
    public function getTarefaRecorrente(){
        return $this->TarefaRecorrenteFactory->getTarefaRecorrente();
    }
}

?>
